#if !defined(TOOL_PROPBOX_H)
#define TOOL_PROPBOX_H

#if !defined(OWL_DIALOG_H)
# include <owl/dialog.h>
#endif
#if !defined(OWL_COLMNHDR_H)
# include <owl/colmnhdr.h>
#endif
#if !defined(TOOL_PROPLIST_H)
# include "proplist.h"
#endif

//
// class TPropertyBox
// ~~~~~ ~~~~~~~~~~~~
// TPropertyBox is the main dialog that
// contains various property items
//
class TPropertyBox : public TDialog {
  public:
    TPropertyBox(TWindow* parent);
   ~TPropertyBox();

    // Override virtuals from TWindow
    //
    TResult EvNotify(uint id, TNotify& notifyInfo);

  protected:
    // Used in derived classes
    //
    TPropListBox* listBox;

    void SetupWindow();

    void EvSize(uint sizeType, TSize& size);

    bool EvTrack   (THdrNotify& nmHdr);
    void EvEndTrack(THdrNotify& nmHdr);

    virtual TResult EvNotifyPropChange (TPropNotify& notifyInfo);
    virtual TResult EvNotifyOwnerDrop  (TPropNotify& notifyInfo);
    virtual TResult EvNotifyPressButton(TPropNotify& notifyInfo);

  private:
    TColumnHeader* header;

    THdrItem* propHdr;
    THdrItem* valueHdr;

    int hdrBottomPos;

    void Resize(bool firstTime = false);

  DECLARE_RESPONSE_TABLE(TPropertyBox);
};

#endif  // TOOL_PROPBOX_H
